﻿////////////////////////////
// Events app
////////////////////////////
Ha.WebApp.Events = Ha.WebApp.Events || {};

Ha.WebApp.Events._statuspopupTimeout = null;
Ha.WebApp.Events.es = null;

Ha.WebApp.Events.InitializePage = function () {
    setTimeout(function () {
        Ha.WebApp.Events.SetupListener();

        $(window).bind('scroll resize', function () {
            $('#statuspopup').css('top', $(this).scrollTop());
        });
    }, 2000);
};

Ha.WebApp.Events.SetupListener = function () {
    Ha.WebApp.Events.es = new EventSource('/Api/EasyIoT/Events/RealTime.EventStream/');
    Ha.WebApp.Events.es.onmessage = function (e) {
        var event = eval('[' + e.data + ']')[0];

        var module = Ha.Data.Module.GetModuleByDomainAddress(event.Domain, event.Address);
        if (module != null) {
            // update property
            var curprop = Ha.WebApp.Utility.GetModulePropertyByName(module, event.Property);

            Ha.WebApp.Utility.SetModulePropertyByName(module, event.Property, event.Value, event.Timestamp);

            Ha.WebApp.Control.SendEventToUi(module, event);

            //var popupdata = null;


            if (curprop.DisableUINotification != "true") {
                var group = '';

                var gr = Ha.Data.Group.GetModuleGroup(module);
                if (gr != null)
                    group = gr.GroupName;

                var data = Ha.WebApp.Control.GetWidgetUIData(module);

                var popupdata = {
                    icon: data.icon,
                    title: '<span style="color:gray;font-size:8pt;">' + group + '</span><br><b>' + module.Description + '</b><br>', // + data.propertyname,
                    text: data.status,
                    timestamp: Ha.WebApp.Control.GetWidgetDateTime(data.timestamp)
                };

                if (popupdata != null)
                    Ha.WebApp.Events.ShowEventPopup(popupdata);
            }
        }
    }
};


Ha.WebApp.Events.ShowEventPopup = function (popupdata) {

    var s = '<table width="100%"><tr><td width="48" rowspan="2">';
    s += '<img src="' + popupdata.icon + '" width="48">';
    s += '</td><td valign="top" align="left" style="color: black;">';
    s += popupdata.title;
    s += '</td><td align="right" style="font-size:12pt;color: black;">' + popupdata.text + '</td></tr>';
    s += '<tr><td colspan="2" align="right"><span style="font-size:8pt;color: black;">' + popupdata.timestamp + '</span>';
    s += '</td></tr></table>';
    $('#statuspopup').html(s);


    // hide timeout
    if (Ha.WebApp.Events._statuspopupTimeout != null) {
        clearTimeout(Ha.WebApp.Events._statuspopupTimeout);
    }
    else {
        $('#statuspopup').css('display', '');
        $('#statuspopup').animate({ opacity: '0' }, 0, function () {
            $('#statuspopup').animate({ right: '5px', opacity: '0.90' }, 300);
        });
    }
    Ha.WebApp.Events._statuspopupTimeout = setTimeout(function () {
        if ($('#statuspopup').css('display') != 'none') {
            $('#statuspopup').animate({ right: '-300px', opacity: '0.0' }, 300, function () {
                $('#statuspopup').css('display', 'none');
            });
        }
        Ha.WebApp.Events._statuspopupTimeout = null;
    }, 5000);


}