﻿/////////////////////////////////////////////////
/// Utility section
/////////////////////////////////////////////////

Ha.WebApp.Utility = Ha.WebApp.Utility || {};


Ha.WebApp.Utility.OpenSubPopUp= function(popup1, popup2){

    var openPopup = function (event, ui) {
        setTimeout(function () { $(popup2).popup('open', { transition: 'pop' }); }, 100);
        $(popup1).off('popupafterclose', openPopup);
    };

    $(popup1).on('popupafterclose', openPopup);
    $(popup1).popup("close");
}


Ha.WebApp.Utility.GetModulePropertyByName = function (module, prop) {
    var value = null;
    if (module.Properties != null) {
        for (var p = 0; p < module.Properties.length; p++) {
            if (module.Properties[p].Name == prop) {
                value = module.Properties[p];
                break;
            }
        }
    }
    return value;
};


Ha.WebApp.Utility.SetModulePropertyByName = function (module, prop, value, timestamp) {
    var found = false;
    if (module.Properties != null) {
        for (var p = 0; p < module.Properties.length; p++) {
            if (module.Properties[p].Name == prop) {
                //module.Properties[p].LastValue = module.Properties[p].Value;
                module.Properties[p].Value = value;
                if (typeof timestamp != 'undefined') {
                    module.Properties[p].UpdateTime = timestamp;
                }
                found = true;
                break;
            }
        }
        if (!found) {
            module.Properties.push({ 'Name': prop, 'Value': value });
        }
    }
};


Ha.WebApp.Utility.FormatDate = function (date) {
    var dt = $.datepicker.formatDate('D, dd/mm/yy', date);
    return dt;
};

Ha.WebApp.Utility.FormatDateTime = function (date, showms) {
    var hh = date.getHours().toString(); if (hh.length == 1) hh = '0' + hh;
    var mm = date.getMinutes().toString(); if (mm.length == 1) mm = '0' + mm;
    var ss = date.getSeconds().toString(); if (ss.length == 1) ss = '0' + ss;
    var dt = hh + ':' + mm + ':' + ss;
    if (showms) dt += '.' + date.getMilliseconds();
    return dt;
};


Ha.WebApp.Utility.GetBasicIconForModule = function (module) {

    var icon;
    if (module.DeviceType == 'S_GENERIC')
        icon = "images/widgets/sensor.png";
    else if (module.DeviceType == 'S_DIGITAL_INPUT')
        icon = "images/widgets/digital_input.png";
    else if (module.DeviceType == 'S_DIGITAL_OUTPUT')
        icon = "images/widgets/socket_off.png";
    else if (module.DeviceType == 'S_DOOR')
        icon = "images/widgets/door_closed.png";
    else if (module.DeviceType == 'S_ANALOG_INPUT')
        icon = "images/widgets/ai.png";
    else if (module.DeviceType == 'S_TEMP')
        icon = "images/widgets/temperature.png";
    else if (module.DeviceType == 'S_HUM')
        icon = "images/widgets/humidity.png";
    else if (module.DeviceType == 'S_BARO')
        icon = "images/widgets/pressure.png";
    else if (module.DeviceType == 'S_LIGHT_LEVEL')
        icon = "images/widgets/radiation.png";
    else if (module.DeviceType == 'S_ANALOG_OUTPUT')
        icon = "images/widgets/ao.png";
    else if (module.DeviceType == 'S_LEAK')
        icon = "images/widgets/leak_ok.png";
    else if (module.DeviceType == 'S_TEMP_AO')
        icon = "images/widgets/temperature.png";
    else if (module.DeviceType == 'S_HUM_AO')
        icon = "images/widgets/humidity.png";
    else if (module.DeviceType == 'S_DIMMER')
        icon = "images/widgets/dimmer.png";
    else if (module.DeviceType == 'S_COVER')
        icon = "images/widgets/cover.png";
    else if (module.DeviceType == 'S_DISTANCE')
        icon = "images/widgets/distance.png";
    else if (module.DeviceType == 'S_DUST')
        icon = "images/widgets/dust.png";
    else if (module.DeviceType == 'S_POWER')
        icon = "images/widgets/power.png";
    else if (module.DeviceType == 'S_WATER')
        icon = "images/widgets/water.png";
    else if (module.DeviceType == 'S_UV')
        icon = "images/widgets/uvindex.png";
    else if (module.DeviceType == 'S_MOTION')
        icon = "images/widgets/motion.png";

    else
        icon = "images/widgets/sensor.png";

    return icon;
};


Ha.WebApp.Utility.GetBasicIcon1ForModule = function (module) {

    var icon = '';
//    if (module.DeviceType == 'S_GENERIC')
//        icon = "images/widgets/sensor.png";
//    else if (module.DeviceType == 'S_DIGITAL_INPUT')
//        icon = "images/widgets/digital_input.png";
if (module.DeviceType == 'S_DIGITAL_OUTPUT')
    icon = "images/widgets/socket_on.png";
else if (module.DeviceType == 'S_DOOR')
        icon = "images/widgets/door_open.png";
//    else if (module.DeviceType == 'S_ANALOG_INPUT')
//        icon = "images/widgets/ai.png";
//    else if (module.DeviceType == 'S_TEMP')
//        icon = "images/widgets/temperature.png";
//    else if (module.DeviceType == 'S_HUM')
//        icon = "images/widgets/humidity.png";
//    else if (module.DeviceType == 'S_BARO')
//        icon = "images/widgets/pressure.png";
//    else if (module.DeviceType == 'S_LIGHT_LEVEL')
//        icon = "images/widgets/radiation.png";
//    else if (module.DeviceType == 'S_ANALOG_OUTPUT')
//        icon = "images/widgets/ao.png";
else if (module.DeviceType == 'S_LEAK')
    icon = "images/widgets/leak_alarm.png";
//    else if (module.DeviceType == 'S_TEMP_AO')
//        icon = "images/widgets/temperature.png";
//    else if (module.DeviceType == 'S_HUM_AO')
//        icon = "images/widgets/humidity.png";
//    else if (module.DeviceType == 'S_DIMMER')
//        icon = "images/widgets/dimmer.png";
//    else if (module.DeviceType == 'S_COVER')
//        icon = "images/widgets/cover.png";
//    else if (module.DeviceType == 'S_DISTANCE')
//        icon = "images/widgets/distance.png";
//    else if (module.DeviceType == 'S_DUST')
//        icon = "images/widgets/dust.png";
//    else if (module.DeviceType == 'S_POWER')
//        icon = "images/widgets/power.png";
//    else if (module.DeviceType == 'S_WATER')
//        icon = "images/widgets/water.png";
//    else if (module.DeviceType == 'S_UV')
//        icon = "images/widgets/uvindex.png";
else if (module.DeviceType == 'S_MOTION')
    icon = "images/widgets/motion_alarm.png";

    if (icon == '')
        icon = Ha.WebApp.Utility.GetBasicIconForModule(module);

    return icon;
};



Ha.WebApp.Utility.GetIconForModule = function (module) {
    var icon = '';

    var ic = Ha.WebApp.Utility.GetModulePropertyByName(module, "Settings.Icon");

    if (ic != null && ic != '' && ic != 'undefined')
        icon = '/images/custom/'+ic.Value;

    if (icon == '')
        icon = Ha.WebApp.Utility.GetBasicIconForModule(module);

    return icon;
};


Ha.WebApp.Utility.GetIcon1ForModule = function (module) {
    var icon = '';

    var ic = Ha.WebApp.Utility.GetModulePropertyByName(module, "Settings.Icon1");

    if (ic != null && ic != '' && ic != 'undefined')
        icon = '/images/custom/'+ic.Value;

    if (icon == '')
        icon = Ha.WebApp.Utility.GetBasicIcon1ForModule(module);

    return icon;
};
